---------------------------------------------------------------------------------------------------------
--88.
CREATE TABLE TB_ORD_88
  (
    ORD_NO CHAR(8)
  , ORD_DE CHAR(8)
  , ORD_TM CHAR(6)
  , PRDT_CD CHAR(4)
  , ORD_CNT NUMBER(10)
  , ORD_AMT NUMBER(10)
  , CONSTRAINT TB_ORD_88_PK PRIMARY KEY (ORD_NO)
  )
  ;

SELECT *
 FROM TB_ORD_88
WHERE ORD_DE BETWEEN '20200101' AND '20201231'
  AND ORD_TM BETWEEN '090000' AND '180000'
  AND PRDT_CD = 'P001'
;
---------------------------------------------------------------------------------------------------------
--98.
CREATE TABLE TB_EMP_98
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, SEX_CD CHAR(2) NOT NULL
, BIRTH_DT CHAR(8) NOT NULL
, JOB_CD CHAR(4) NULL
, DEPT_CD CHAR(4) NULL
, CONSTRAINT TB_EMP_98_PK PRIMARY KEY (EMP_NO)
)
;

INSERT INTO TB_EMP_98
SELECT
      LPAD(ROWNUM, 6, '0') AS EMP_NO
    , DBMS_RANDOM.STRING('U', 6)
    , TO_CHAR(CEIL(MOD(DBMS_RANDOM.VALUE(1, 1000), 2)))
    , TO_CHAR(SYSDATE - DBMS_RANDOM.VALUE(1, 3650), 'YYYYMMDD')
    , LPAD(TO_CHAR(TRUNC(DBMS_RANDOM.VALUE(1, 10))), 4, '0')
    , LPAD(TO_CHAR(TRUNC(DBMS_RANDOM.VALUE(1, 10))), 4, '0')
FROM DUAL CONNECT BY LEVEL <= 100000;

COMMIT;

SELECT *
  FROM TB_EMP_98
  WHERE BIRTH_DT BETWEEN '20170101' AND '20191231'
    AND DEPT_CD = '0001'
    AND JOB_CD = '0002'
    AND SEX_CD <> '1'
;
---------------------------------------------------------------------------------------------------------
--99.
CREATE TABLE TB_EMP_99
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, SEX_CD CHAR(2) NOT NULL
, BIRTH_DT CHAR(8) NOT NULL
, JOB_CD CHAR(4) NULL
, DEPT_CD CHAR(4) NULL
, CONSTRAINT TB_EMP_99_PK PRIMARY KEY (EMP_NO)
)
;

INSERT INTO TB_EMP_99
SELECT
      LPAD(ROWNUM, 6, '0') AS EMP_NO
    , DBMS_RANDOM.STRING('U', 6)
    , TO_CHAR(CEIL(MOD(DBMS_RANDOM.VALUE(1, 1000), 2)))
    , TO_CHAR(SYSDATE - DBMS_RANDOM.VALUE(1, 3650), 'YYYYMMDD')
    , LPAD(TO_CHAR(TRUNC(DBMS_RANDOM.VALUE(1, 10))), 4, '0')
    , LPAD(TO_CHAR(TRUNC(DBMS_RANDOM.VALUE(1, 10))), 4, '0')
FROM DUAL CONNECT BY LEVEL <= 100000;

COMMIT;

SELECT /*+ INDEX(TB_EMP_99 IDX_TB_EMP_99_01) */
      *
 FROM TB_EMP_99
WHERE BIRTH_DT BETWEEN '20200101' AND '20201231'
  AND SEX_CD = '1'
  AND JOB_CD = '0007'
  AND DEPT_CD = '0007'
 ;
